#! /bin/sh
# 4 47 1.4 src/pdwebars/Deploy.sh, pdweb.dynadi, amweb510, 031011a 9/11/03 13:29:11

#deploy AMWebARS to WAS

if [ -z "$1" -o -z "$2" -o \( -n "$3" -a ! \( "$3" = "-user" -a -n "$4" -a "$5" = "-password" -a -n "$6" \) \) -o -n "$7" ] ; then
    echo "\n
Usage: Deploy.sh <WebSphere install path> <WebSphere server name> [-user <username> -password <password>]\n
       where:
	<WebSphere install path> is the path on the local machine
		that contains the WebSphere /bin directory 
		(e.g. /usr/WebSphere/AppServer). \n
	<WebSphere server name> is the name of the WebSphere instance
		to deploy the application to. (e.g. server1)\n
	<username> is the username of a valid WAS administrator\n
	<password> is the password for the above WAS administrator\n\n"
    exit 0
fi

echo "WebSphere install path = $1" > Deploy.log
echo "WebSphere server name = $2" >> Deploy.log

WS_INSTALL_PATH=$1
WS_SERVER_NAME=$2
 
if [ -n "$3" ] ; then
	USER=$4
	PASSWORD=$6
	FOUNDPASSWORD=1
else
	FOUNDPASSWORD=0
fi

echo "\$AdminApp install amwebars.ear" > tmp.tcl
echo "\$AdminConfig save" >> tmp.tcl
echo "\$AdminControl stopServer $WS_SERVER_NAME" >> tmp.tcl

COPY_FAILED=0

echo "Deploying AMWebARS to WAS..."

if [ $FOUNDPASSWORD = "1" ] ; then
	$WS_INSTALL_PATH/bin/wsadmin.sh -user $USER -password $PASSWORD -f tmp.tcl 2>&1 >> Deploy.log
	if [ $? -ne 0 ] ; then
        	echo "Deploy Failed... Please check that WAS is running..."
		echo "Also, if WAS Global Security is Enabled, ensure that you are providing the '-user' and '-password' input arguments for a valid WAS administrator..."
        	echo "See Deploy.log for details..." 
        	exit 1
	fi
else
	$WS_INSTALL_PATH/bin/wsadmin.sh -f tmp.tcl 2>&1 >> Deploy.log
	if [ $? -ne 0 ] ; then
        	echo "Deploy Failed... Please check that WAS is running..."
		echo "Also, if WAS Global Security is Enabled, ensure that you are providing the '-user' and '-password' input arguments for a valid WAS administrator..."
        	echo "See Deploy.log for details..." 
        	exit 1
	fi
fi
rm tmp.tcl

echo "Deploy Complete..."
echo "Copying AMWebARS config files to WAS working directory..."
cp amwebars.conf $WS_INSTALL_PATH/.
if [ $? -ne 0 ] ; then
	COPY_FAILED=1
fi
cp ContainerDatabase.xml $WS_INSTALL_PATH/.
if [ $? -ne 0 ] ; then
	COPY_FAILED=1
fi
cp ContainerDescriptorTable.xml $WS_INSTALL_PATH/.
if [ $? -ne 0 ] ; then
	COPY_FAILED=1
fi
cp ProtocolTable.xml $WS_INSTALL_PATH/.
if [ $? -ne 0 ] ; then
	COPY_FAILED=1
fi
cp ProviderTable.xml $WS_INSTALL_PATH/.
if [ $? -ne 0 ] ; then
	COPY_FAILED=1
fi
cp Service.map $WS_INSTALL_PATH/.
if [ $? -ne 0 ] ; then
	COPY_FAILED=1
fi
cp test_keystore $WS_INSTALL_PATH/.
if [ $? -ne 0 ] ; then
	COPY_FAILED=1
fi

if [ $COPY_FAILED -ne 0 ] ; then
	echo "One or more AMWebARS config files could not be copied to the correct location.  
To ensure proper operation, make sure that the following files:
\t- ContainerDatabase.xml
\t- ContainerDescriptorTable.xml
\t- ProtocolTable.xml
\t- ProviderTable.xml
\t- Service.map
\t- amwebars.conf
\t- test_keystore
are present in the following directory:
\t- $WS_INSTALL_PATH\n"
else
	echo "Copy complete..."
fi

echo "Restarting WAS..."
$WS_INSTALL_PATH/bin/startServer.sh $WS_SERVER_NAME 2>&1 >> Deploy.log
if [ $? -ne 0 ] ; then
        echo "Failed to start WAS... See Deploy.log for details." 
        exit 1
fi

echo "WAS restarted..."
echo "The AMWebARS is available at:
\thttp(s)://<server>:<port>/amwebars/amwebars/ServiceToIServicePortAdapter"
exit 0
