#! /bin/sh
# 4 66 1.4 src/pdwebars/unDeploy.sh, pdweb.dynadi, amweb510, 031011a 9/11/03 13:29:11

#undeploy AMWebARS from WAS

if [ -z "$1" -o \( -n "$2" -a ! \( "$2" = "-user" -a -n "$3" -a "$4" = "-password" -a -n "$5" \) \) -o -n "$6" ] ; then
    echo "\n
Usage: Deploy.sh <WebSphere install path> [-user <username> -password <password>]\n
       where:
	<WebSphere install path> is the path on the local machine
		that contains the WebSphere /bin directory 
		(e.g. /usr/WebSphere/AppServer). \n
        <username> is the username of a valid WAS administrator\n
        <password> is the password for the above WAS administrator\n\n"
    exit 0
fi

echo "WebSphere install path = $1" > unDeploy.log

WS_INSTALL_PATH=$1

if [ -n "$2" ] ; then
        USER=$3
        PASSWORD=$5
        FOUNDPASSWORD=1
else
        FOUNDPASSWORD=0
fi

echo "\$AdminApp uninstall amwebars" > tmp.tcl
echo "\$AdminConfig save" >> tmp.tcl

echo "Removing AMWebARS from WAS..."

if [ $FOUNDPASSWORD = "1" ] ; then
        $WS_INSTALL_PATH/bin/wsadmin.sh -user $USER -password $PASSWORD -f tmp.tcl 2>&1 >> unDeploy.log
        if [ $? -ne 0 ] ; then
                echo "Removal Failed... Please check that WAS is running..."
                echo "Also, if WAS Global Security is Enabled, ensure that you are providing the '-user' and '-password' input arguments for a valid WAS administrator..."
                echo "See unDeploy.log for details..."
                exit 1
        fi
else
        $WS_INSTALL_PATH/bin/wsadmin.sh -f tmp.tcl 2>&1 >> Deploy.log
        if [ $? -ne 0 ] ; then
                echo "Removal Failed... Please check that WAS is running..."
                echo "Also, if WAS Global Security is Enabled, ensure that you are providing the '-user' and '-password' input arguments for a valid WAS administrator..."
                echo "See unDeploy.log for details..."
                exit 1
        fi
fi
rm tmp.tcl

echo "Removal complete..."

echo "Deleting AMWebARS config files from WAS working directory..."

rm $WS_INSTALL_PATH/amwebars.conf
rm $WS_INSTALL_PATH/ContainerDatabase.xml
rm $WS_INSTALL_PATH/ContainerDescriptorTable.xml
rm $WS_INSTALL_PATH/ProtocolTable.xml
rm $WS_INSTALL_PATH/ProviderTable.xml
rm $WS_INSTALL_PATH/Service.map
rm $WS_INSTALL_PATH/test_keystore

echo "Deletion complete..."

echo "The AMWebARS has been undeployed..."

exit 0
