#ifndef CDMF_H_SOURCECODEID
#define CDMF_H_SOURCECODEID
static char cdmf_h_sourceCodeID[]="$Id: @(#)02  1.2.2.1 src/pdwebrte/cdsso/cdmf.h, pdweb.cdsso, amweb510, 031011a 03/09/25 13:06:42 $";
#endif

/*                       
 *
 * Component Name: pdweb.cdsso
 * File Name: cdmf.h
 *
 * Licensed Materials - Property of IBM
 * 5748-XX8
 * (c) Copyright International Business Machines Corp. 2000,2001
 * US Government Users Restricted Rights - Use, duplicaion or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * All Rights Reserved.
 */

/*
 * Cross Domain Mapping Framework (CDMF)
 */
                       
#ifndef _CDMF_H
#define _CDMF_H

#include <cdssotypes.h>

/* Function return codes */
#define CDMF_SUCCESS	(0)
#define CDMF_FAILURE	(1)
#define CDMF_NOMAP	(2)

#if defined(WIN32) || defined(_WIN32)
#if defined(CDMF_DLL)
#define CDMF_DECLSPEC       __declspec( dllexport )
#else
#define CDMF_DECLSPEC       __declspec( dllimport )
#endif
#define CDMF_CALLTYPE       __cdecl
#else /* WIN32 */
#define CDMF_DECLSPEC
#define CDMF_CALLTYPE
#endif /* WIN32 */

#ifdef __cplusplus
extern "C" {
#endif


/*
 * cdmf_map_usr
 *
 * Map a remote user to a local user.
 *
 * ARGUMENTS
 *
 * cdsso_user_info_t * - [IN]     Out of domain user
 * cdsso_user_info_t * - [IN/OUT] User in the local domain                
 *
 * RETURNS - CDMF_SUCCESS on success, 
 *           CDMF_NOMAP	  if no user mapping available
 *           CDMF_FAILURE on failure
 */
CDMF_DECLSPEC
int 
CDMF_CALLTYPE
cdmf_map_usr(
    cdsso_user_info_t *remote_usr, 
    cdsso_user_info_t *local_usr);


/*
 * cdmf_get_usr_attributes
 *
 * Obtain the attributes for the specified user.
 *
 * ARGUMENTS
 *
 * char *              - [IN]  User name
 * cdsso_attrlist_t ** - [OUT] Attributes for specified user
 *
 * RETURNS - CDMF_SUCCESS on success
 * 	     CDMF_FAILURE otherwise
 */
CDMF_DECLSPEC
int
CDMF_CALLTYPE
cdmf_get_usr_attributes(
    char *usr, 
    cdsso_attrlist_t **attr_list);

#ifdef __cplusplus
}
#endif

#endif /* include guard */

