#ifndef CDSSOTYPES_H_SOURCECODEID
#define CDSSOTYPES_H_SOURCECODEID
static char cdssotypes_h_sourceCodeID[]="$Id: @(#)00  1.2.2.2 src/pdwebrte/cdsso/cdssotypes.h, pdweb.cdsso, amweb510, 040211a 03/12/10 18:13:33 $";
#endif

/*                       
 *
 * Component Name: pdweb.cdsso
 * File Name: cdssotypes.h
 *
 * Licensed Materials - Property of IBM
 * 5748-XX8
 * (c) Copyright International Business Machines Corp. 2000,2001
 * US Government Users Restricted Rights - Use, duplicaion or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * All Rights Reserved.
 */

#ifndef _CDSSOTYPES_H
#define _CDSSOTYPES_H

#include <stdlib.h>

#ifdef _WIN32
#ifndef strdup
#define strdup _strdup
#endif
#endif

/*
 * Type representing a user attribute
 */
typedef struct cdsso_user_attr
{
    char               *attr_name;
    size_t             num_values;
    char               **attr_values;
} cdsso_usr_attr_t;


/*
 * Type representing a list of user attributes
 */
typedef struct cdsso_attrlist
{
    size_t           len;  
    cdsso_usr_attr_t **list;
} cdsso_attrlist_t;


/*
 * Type that holds information about a CDSSO participant 
 */
typedef struct cdsso_user_info
{
    char             *user;
    char             *domain;
    cdsso_attrlist_t *attr_list;
} cdsso_user_info_t;

/*
 * Used to pass information through to the ivauthn layer.
 */
typedef struct ivauthn_cdsso_info {
    char             *user;
    char             *domain;
    cdsso_attrlist_t *attrlist;
} ivauthn_cdsso_info_t;

#endif /* include guard */

