static char pwdstrg_c_sourceCodeID[]="$Id: @(#)99  1.4.1.1 src/pdweb/ivauthn/modules/pwdstrauthn/pwdstrg.c, pdweb.authn, amweb510, 031011a 03/09/25 13:08:53 $";

/*
 * HISTORY
 * $Log: pwdstrg.c,v $
 * Revision 1.1.2.4  2000/03/23  00:56:11  mrodkey
 * 	fix for bug 6229
 *
 * Revision 1.1.3.2  2000/03/23  00:55:46  mrodkey
 * 	fix for bug 6229
 *
 * Revision 1.1.2.3  2000/03/14  20:01:28  mrodkey
 * 	fix for 6226
 * 
 * Revision 1.1.3.2  2000/03/14  20:00:51  mrodkey
 * 	fix for 6226
 * 
 * Revision 1.1.2.2  2000/02/25  22:29:21  mrodkey
 * 	Updated the way that libpwdstrauthn is built
 * 
 * Revision 1.1.3.2  2000/02/25  22:28:55  mrodkey
 * 	Updated the way that libpwdstrauthn is built
 * 
 * Revision 1.1.2.1  2000/02/24  20:31:05  mrodkey
 * 	Password Strength Exit
 * 
 * Revision 1.1.1.2  2000/02/24  20:30:30  mrodkey
 * 	Password Strength Exit
 * 
 * $EndLog$
 */

#include <string.h>

#define     PWD_OK  1
#define     PWD_BAD 0


/*
 * password_strength:
 *      This function can be configured to provide any sort of password 
 *      strength checking.
 *      PARAMETERS:
 *          username - the user who is changing their password
 *          old_password - the old password for the user
 *          new_password - the new password for the user
 *      RETURNS:
 *          PWD_OK if the new password is valid
 *          PWD_BAD if the new password is invalid
 */
int
password_strength(
	char	*username,
	char	*old_password,
	char	*new_password)
{
    int     retval = PWD_OK;
    int     PWD_MAX_LENGTH = 10;

    /* 
     * Enforce that user user cannot use their old password 
     * for their new one
     */
    if (strcmp(old_password, new_password) == 0) {
        retval = PWD_BAD;
        return retval;
    }

    /*
     * Enforce Maximum Length Policy for passwords
     */
    if (strlen(new_password) > PWD_MAX_LENGTH) {
        retval = PWD_BAD;
        return retval;
    }


	return retval;
}
